.model small, farstack
.486

fpbyte          typedef far ptr byte

.data
                ;       0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F 10 11 12 13 14 15 16 17 18 19 1A 1B 1C 1D 1E 1F
op2ch           byte    0, 1, 2, 0, 1, 2,-1,-1, 3, 4, 5, 3, 4, 5,-1,-1, 6, 7, 8, 6, 7, 8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
op2slot         byte    0, 0, 0, 3, 3, 3,-1,-1, 0, 0, 0, 3, 3, 3,-1,-1, 0, 0, 0, 3, 3, 3,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
ch2op           byte    0, 1, 2, 8, 9,10,16,17,18
chRemap         byte    0, 1, 2, 3, 4, 5, 6, 7, 8
vgmName         byte    "MAPPED.VGM", 0
vgmWait         dword   0
vgmPosition     word    0
ChainCount      word    0

.data?
chNewRemap      byte    9 dup (?)

.fardata
vgmData         byte    65535 dup (?)

.code
start:          mov     ax, @data
                mov     ds, ax
                call    LoadVGM
                call    SetupTimer
                mov     ah, 0
                int     16h
                call    ResetTimer
                call    SilenceOPL
                mov     ax, 4C00h
                int     21h

LoadVGM         proc
                mov     ax, 3D00h
                mov     dx, offset vgmName
                int     21h
                mov     bx, ax
                push    ds
                assume  ds:seg vgmData
                mov     ah, 3Fh
                mov     cx, 65535
                mov     dx, seg vgmData
                mov     ds, dx
                mov     dx, offset vgmData
                int     21h
                mov     ax, word ptr ds:[vgmData +34h +0]
                add     ax, 34h
                add     ax, offset vgmData
                pop     ds
                assume  ds:@data
                mov     [vgmPosition], ax
                mov     ah, 3Eh
                int     21h
                ret
LoadVGM         endp

SetupTimer      proc
                cli
                push    es
                mov     ax, 3508h
                int     21h
                mov     word ptr [vector08+0], bx
                mov     word ptr [vector08+2], es
                pop     es
                push    ds
                mov     ax, 2508h
                push    cs
                pop     ds
                mov     dx, offset TimerService
                int     21h
                pop     ds
                mov     al, 36h
                out     43h, al
                mov     al, 00h
                out     40h, al
                mov     al, 10h
                out     40h, al
                sti
                ret
SetupTimer      endp

ResetTimer      proc
                cli
                mov     al, 36h
                out     43h, al
                mov     al, 00h
                out     40h, al
                jmp     $+2
                out     40h, al
                push    ds
                mov     ax, 2508h
                lds     dx, [Vector08]
                int     21h
                pop     ds
                sti
                ret
ResetTimer      endp

TimerService    proc    far
                pushad
                push    ds
                push    es
                cld
                mov     ax, @data
                mov     ds, ax
                mov     ax, seg vgmData
                mov     es, ax
                mov     si, offset vgmData
                add     si, [vgmPosition]
NextCommand:    cmp     [vgmWait], 150
                ja      NothingMore
                lods    byte ptr es:[si]
                inc     [vgmPosition]
                .if     al == 61h
                        lods    word ptr es:[si]
                        add     [vgmPosition], 2
                .elseif al == 62h
                        mov     ax, 735
                .elseif al == 63h
                        mov     ax, 882
                .elseif al == 66h
                        ; Get new channel mapping
                        mov     cx, 9
                        mov     di, offset chNewRemap
@@:                     lods    byte ptr es:[si]
                        mov     ah, 0
                        mov     bx, ax
                        mov     al, [bx+chRemap]
                        mov     [di], al
                        inc     di
                        loop    @b
                        xor     bx, bx
@@:                     mov     al, [bx+ chNewRemap]
                        mov     [bx+ chRemap], al
                        inc     bx
                        cmp     bl, 9
                        jb      @b
                        ; Go to loop start
                        mov     ax, word ptr es:[vgmData +1Ch +0]
                        add     ax, 1Ch
                        add     ax, offset vgmData
                        mov     si, ax
                        mov     [vgmPosition], ax

                        xor     ax, ax
                .elseif al == 5Ah
                        mov     dx, 0388h
                        lods    word ptr es:[si]
                        call    RemapOPL
                        out     dx, ax
                        add     [vgmPosition], 2
                        xor     ax, ax
                .else
                        mov     ax, 0FFFFh
                .endif
                add     word ptr [vgmWait+0], ax
                adc     word ptr [vgmWait+2], 0
                jmp     NextCommand
NothingMore:    sub     [vgmWait], 150
                add     [ChainCount], 1000h
                jc      Chain08
                mov     al, 20h
                out     20h, al
                pop     es
                pop     ds
                popad
                iret
Chain08:        pop     es
                pop     ds
                popad
                byte    0EAh                
Vector08        fpbyte  ?
TimerService    endp

SilenceOPL      proc
                mov     dx, 388h
                mov     ax, 00B0h
@@:             out     dx, ax
                inc     ax
                cmp     al, 0B9h
                jb      @b
                ret
SilenceOPL      endp

RemapOPL        proc
                mov     bl, al
                mov     cl, al
                .if     al >= 0A0h && al < 0E0h
                        and     bx, 00Fh
                        and     cl, 0F0h
                        mov     al, [bx +chRemap]
                        or      al, cl
                .elseif (al >= 020h && al < 0A0h) || \
                        (al >= 0E0h && al < 0F6h)
                        and     bx, 01Fh
                        and     cl, 0E0h
                        mov     ch, [bx+ op2slot]
                        mov     bl, [bx+ op2ch]
                        mov     bl, [bx +chRemap]
                        mov     al, [bx +ch2op]
                        add     al, ch
                        add     al, cl
                .endif
                ret
RemapOPL        endp

.stack
                end     start
